<?php

function tribune_totoz_info() {

	$info = array(
		'description' => t("Allows users to post [:totoz]s"),
		'weight' => 10,
	);

	return $info;
}

function tribune_totoz_filter_after(&$post, &$help) {
	// if using the filter_after hook, the filter will be executed after the
	// message is parsed, and will be able to add arbitrary HTML. The filter
	// will also be executed when the admin hits the "Parse visible messages
	// again" button and will not be able to post new messages.

	$image_url = variable_get("tribune_smileys_server", "http://sfw.totoz.eu")."/$2.gif";
	$replacement_string  = "<a href='".$image_url."' class='tribune-totoz'>$1";
	$replacement_string .= "<img src='".$image_url."' alt='$2' />";
	$replacement_string .= "</a>";

	// since this filter executes after a message is parsed, it has to use
	// the 'parsed' index instead of the 'message' one.
	$post['parsed'] = preg_replace("/(\[:((\w| |_|-)+)\])/",
							$replacement_string,
							$post['parsed']);
}

function tribune_totoz_help() {
	// this function is called everytime the tribune is loaded, either the
	// full page or the block, it is a good place to add javascript or css

	drupal_add_js(array(
				"tribune" => array(
					"totoz" => array(
						'server' => variable_get("tribune_smileys_server", "http://sfw.totoz.eu"),
						),
					),
				), "setting");

    drupal_add_js (drupal_get_path('module', 'tribune').'/filters/totoz.js');
    drupal_add_css(drupal_get_path('module', 'tribune').'/filters/totoz.css');


	$description .= t('You can insert smileys in your post this way: '
					 .'[:smiley]. See all the available smileys or add a '
					 .'new one at <a href="');

	// hardware.fr's list isn't at the same address
	switch (variable_get("tribune_smileys_server", "http://sfw.totoz.eu")) {
		case "http://forum.hardware.fr/images/perso":
			$description .= "http://forum.hardware.fr/smilieperso.php";
			break;
		default:
			$description .= variable_get("tribune_smileys_server", "http://sfw.totoz.eu");
			break;
	}

	$description .= t('">this address');
	$description .= '</a>';

	return $description;
}

function tribune_totoz_settings() {
	$link1 = l(t('safe'), 'http://forum.hardware.fr/smilieperso.php');
	$link2 = l(t('safe'), 'http://sfw.totoz.eu');
	$link3 = l(t('not safe for all audiences'), 'http://totoz.eu');
	$servers_list = t('<ul><li>http://forum.hardware.fr/images/perso (!link1)</li><li>http://sfw.totoz.eu (!link2)</li><li>http://totoz.eu (!link3)</li></ul>',
					  array('!link1' => $link1, '!link2' => $link2, '!link3' => $link3));
	$servers_help = t('The server from which to retrieve the smileys. Known servers are:!list', array('!list' => $servers_list));

	$form = array();

    $form['tribune_totoz_server'] = array(
		'#type'         => 'textfield',
		'#title'        => t('Totoz server'),
		'#default_value'=> variable_get('tribune_smileys_server', 'http://sfw.totoz.eu'),
		'#description'  => $servers_help,
	);

	return system_settings_form($form);
}
